using MediatR;
using Microsoft.AspNetCore.SignalR;
using Sledgemapper.Api.Notifications;
using Sledgemapper.Clients;
using System.Threading;
using System.Threading.Tasks;
using Sledgemapper.Api.Hubs;

namespace Sledgemapper.Api.Handlers
{
    public class SendNewNoteMessage : INotificationHandler<NewNoteNotification>
    {
        private readonly IHubContext<SledgemapperHub, ISledgemapperClient> _hub;

        public SendNewNoteMessage(IHubContext<SledgemapperHub, ISledgemapperClient> hub) => _hub = hub;

        public async Task Handle(NewNoteNotification notification, CancellationToken cancellationToken)
        {
            await _hub.Clients.Groups(notification.Session.SessionName).NewNote(notification.Note);
        }
    }
}
